%define DATE 20020515
%define gcc_version 3.1
%define gcc_release 1
Summary: Various compilers (C, C++, Objective-C, Java, ...)
Name: gcc3
Version: 3.1
Release: %{gcc_release}
Copyright: GPL
Group: Development/Languages
Source0: gcc-%{version}-%{DATE}.tar.bz2
URL: http://gcc.gnu.org
BuildRoot: /var/tmp/gcc-root
BuildRequires: binutils >= 2.11.93.0.2-12
BuildRequires: zlib-devel, gettext, dejagnu
# Need .eh_frame ld optimizations
# Need proper visibility support
Requires: binutils >= 2.11.93.0.2-12
# Make sure gdb will understand DW_FORM_strp
Conflicts: gdb < 5.1-2
Requires: glibc-devel
Requires: libgcc >= %{version}-%{release}
Prereq: /sbin/install-info

Patch1: gcc31-2.96-RH-compat.patch
Patch2: gcc31-boehm-gc-libs.patch
Patch3: gcc31-bogus-inline.patch
Patch4: gcc31-complit-reference.patch
Patch5: gcc31-complit-const.patch
Patch6: gcc31-fde-merge-compat.patch
Patch7: gcc31-attr-visibility.patch
Patch8: gcc31-attr-visibility2.patch
Patch9: gcc31-duplicate-decl.patch
Patch10: gcc31-trunc_int_for_mode.patch
Patch11: gcc31-sparc-sll1.patch
Patch12: gcc31-x86_64-q_regs_operand.patch
Patch13: gcc31-dwarf2-pr6381.patch
Patch14: gcc31-dwarf2-pr6436-test.patch
Patch15: gcc31-c++-null-pm-init.patch
Patch16: gcc31-c++-tsubst-asm.patch
Patch17: gcc31-fdata-sections.patch
Patch18: gcc31-fold-const.patch
Patch19: gcc31-fold-const2.patch
Patch20: gcc31-i386-malign-double-doc.patch
Patch21: gcc31-libstdc++-pr6594.patch
Patch22: gcc31-libstdc++-pr6648.patch
Patch23: gcc31-libstdc++-setrlim.patch
Patch24: gcc31-pr6643.patch
Patch25: gcc31-s390-java.patch
Patch26: gcc31-test-rotate.patch
Patch27: gcc31-x86_64-libiberty-pic.patch
Patch28: gcc31-x86_64-multilib.patch
Patch29: gcc31-x86_64-thunks.patch

%description
The gcc3 package contains the GNU Compiler Collection version 3.1.

%package -n libgcc
Summary: GCC version 3.1 shared support library
Group: System Environment/Libraries

%description -n libgcc
Some GCC version 3.0 and later compiled libraries and/or binaries
need this shared support library.

%package c++
Summary: C++ support for GCC
Group: Development/Languages
Requires: gcc3 = %{version}-%{release}
Requires: libstdc++3 = %{version}
Requires: libstdc++3-devel = %{version}

%description c++
This package adds C++ support to the GNU Compiler Collection version 3.1.
It includes support for most of the current C++ specification,
including templates and exception handling.

%package -n libstdc++3
Summary: GNU Standard C++ Library for GCC 3.1
Group: System Environment/Libraries

%description -n libstdc++3
The libstdc++ package contains a rewritten standard compliant GCC Standard
C++ Library for GCC 3.1.

%package -n libstdc++3-devel
Summary: Header files and libraries for C++ development
Group: Development/Libraries
Requires: libstdc++3 = %{version}-%{release}

%description -n libstdc++3-devel
This is the GNU implementation of the standard C++ libraries.  This
package includes the header files and libraries needed for C++
development. This includes rewritten implementation of STL.

%package objc
Summary: Objective-C support for GCC version 3.1
Group: Development/Languages
Requires: gcc3 = %{version}-%{release}
Requires: gcc-objc >= 2.96-94

%description objc
gcc3-objc provides Objective-C support for the GCC version 3.1.
Mainly used on systems running NeXTSTEP, Objective-C is an
object-oriented derivative of the C language.

%package g77
Summary: Fortran 77 support for GCC version 3.1
Group: Development/Languages
Requires: gcc3 = %{version}-%{release}
Requires: libf2c = %{version}-%{release}
Prereq: /sbin/install-info

%description g77
The gcc3-g77 package provides support for compiling Fortran 77
programs with the GNU Compiler Collection version 3.1.

%package -n libf2c
Summary: Fortran 77 runtime for GCC 3.1
Group: System Environment/Libraries

%description -n libf2c
This package contains Fortran 77 shared library which is needed to run
Fortran 77 3.1 dynamically linked programs.

%package java
Summary: Java support for GCC version 3.1
Group: Development/Languages
Requires: gcc3 = %{version}-%{release}
Requires: libgcj3 >= %{version}, libgcj3-devel >= %{version}

%description java
This package adds support for compiling Java(tm) programs and
bytecode into native code.

%package -n libgcj3
Summary: Java runtime library for gcc version 3.1
Group: System Environment/Libraries
Requires: zip >= 2.1
Obsoletes: gcc-libgcj
# Kaffe includes jar too
Conflicts: kaffe

%description -n libgcj3
The Java(tm) runtime library. You will need this package to run your Java
programs compiled using the Java compiler from GNU Compiler Collection (gcj3).

%package -n libgcj3-devel
Summary: Libraries for Java development using GCC version 3.1
Group: Development/Languages
Requires: zip >= 2.1, libgcj3 = %{version}

%description -n libgcj3-devel
The Java(tm) static libraries and C header files. You will need this
package to compile your Java programs using the GCC Java compiler (gcj3).

%prep
%setup -q -n gcc-%{version}-%{DATE}
%patch1 -p0 -b .2.96-RH-compat
%patch2 -p0 -b .boehm-gc-libs
%patch3 -p0 -b .bogus-inline
%patch4 -p0 -b .complit-reference
%patch5 -p0 -b .complit-const
%patch6 -p0 -b .fde-merge-compat
%patch7 -p0 -b .attr-visibility
%patch8 -p0 -b .attr-visibility2
%patch9 -p0 -b .duplicate-decl
%patch10 -p0 -b .trunc_int_for_mode
%patch11 -p0 -b .sparc-sll1
%patch12 -p0 -b .x86_64-q_regs_operand
%patch13 -p0 -b .dwarf2-pr6381
%patch14 -p0 -b .dwarf2-pr6436-test
%patch15 -p0 -b .c++-null-pm-init
%patch16 -p0 -b .c++-tsubst-asm
%patch17 -p0 -b .fdata-sections
%patch18 -p0 -b .fold-const
%patch19 -p0 -b .fold-const2
%patch20 -p0 -b .i386-malign-double-doc
%patch21 -p0 -b .libstdc++-pr6594
%patch22 -p0 -b .libstdc++-pr6648
%patch23 -p0 -b .libstdc++-setrlim
%patch24 -p0 -b .pr6643
%patch25 -p0 -b .s390-java
%patch26 -p0 -b .test-rotate
%patch27 -p0 -b .x86_64-libiberty-pic
%patch28 -p0 -b .x86_64-multilib
%patch29 -p0 -b .x86_64-thunks

# The binutils requires by this package already contain the necessary fixes
perl -pi -e 's/20020404/20020207/' gcc/configure.in gcc/configure

perl -pi -e 's/"%{gcc_version}"/"%{gcc_version} \(release\)"/' gcc/version.c
perl -pi -e 's/\((prerelease|experimental|release)\)/\(Red Hat Linux 7.3 %{version}-%{gcc_release}\)/' gcc/version.c gcc/f/version.c
perl -pi -e 's/#define GCCBUGURL.*$/#define GCCBUGURL "<URL:http:\/\/bugzilla.redhat.com\/bugzilla\/>"/' gcc/system.h

./contrib/gcc_update --touch

%build
rm -fr obj-%{_target_platform}
mkdir obj-%{_target_platform}
cd obj-%{_target_platform}

CC=gcc
OPT_FLAGS=`echo $RPM_OPT_FLAGS|sed -e 's/-fno-rtti//g' -e 's/-fno-exceptions//g'`
CC="$CC" CFLAGS="$OPT_FLAGS" CXXFLAGS="$OPT_FLAGS" XCFLAGS="$OPT_FLAGS" TCFLAGS="$OPT_FLAGS" \
	../configure --prefix=%{_prefix} --mandir=%{_mandir} --infodir=%{_infodir} \
	--enable-shared --enable-threads=posix --disable-checking --host=%{_target_platform} \
	--with-system-zlib

# if RPM_BUILD_NCPUS unset, set it
if [ -z "$RPM_BUILD_NCPUS" ] ; then
  if [ -x /usr/bin/getconf ] ; then
    RPM_BUILD_NCPUS=$(/usr/bin/getconf _NPROCESSORS_ONLN)
    if [ $RPM_BUILD_NCPUS -eq 0 ]; then
      RPM_BUILD_NCPUS=1
    fi
  else
    RPM_BUILD_NCPUS=1
  fi
fi

make -j$RPM_BUILD_NCPUS bootstrap-lean
#make -j$RPM_BUILD_NCPUS bootstrap

# run the tests.
make -j$RPM_BUILD_NCPUS -k check || :
echo ====================TESTING=========================
../contrib/test_summary || :
echo ====================TESTING END=====================

# Make protoize
make -C gcc CC="./xgcc -B ./ -O2" proto

# Make generated man pages even if Pod::Man is not new enough
perl -pi -e 's/head3/head2/' ../contrib/texi2pod.pl
for i in ../gcc/doc/*.texi; do
  cp -a $i $i.orig; sed 's/ftable/table/' $i.orig > $i
done
make -C gcc generated-manpages
for i in ../gcc/doc/*.texi; do mv -f $i.orig $i; done

# Copy various doc files here and there
cd ..
mkdir -p rpm.doc/g77 rpm.doc/objc
mkdir -p rpm.doc/boehm-gc rpm.doc/fastjar rpm.doc/libffi rpm.doc/libjava

(cd gcc/f; for i in ChangeLog*; do
	cp -p $i ../../rpm.doc/g77/$i.f
done)
(cd libf2c; for i in ChangeLog*; do
	cp -p $i ../rpm.doc/g77/$i.libf2c
done)
(cd gcc/objc; for i in README*; do
	cp -p $i ../../rpm.doc/objc/$i.objc
done)
(cd libobjc; for i in README*; do
	cp -p $i ../rpm.doc/objc/$i.libobjc
done)
(cd boehm-gc; for i in ChangeLog*; do
	cp -p $i ../rpm.doc/boehm-gc/$i.gc
done)
(cd fastjar; for i in ChangeLog* README*; do
	cp -p $i ../rpm.doc/fastjar/$i.fastjar
done)
(cd libffi; for i in ChangeLog* README* LICENSE; do
	cp -p $i ../rpm.doc/libffi/$i.libffi
done)
(cd libjava; for i in ChangeLog* README*; do
	cp -p $i ../rpm.doc/libjava/$i.libjava
done)

%install
rm -fr $RPM_BUILD_ROOT

perl -pi -e \
  's~href="l(ibstdc|atest)~href="http://gcc.gnu.org/onlinedocs/libstdc++/l\1~' \
  libstdc++-v3/docs/html/documentation.html
ln -sf documentation.html libstdc++-v3/docs/html/index.html
find libstdc++-v3/docs/html -name CVS | xargs rm -rf

cd obj-%{_target_platform}
TARGET_PLATFORM=%{_target_platform}

# There are some MP bugs in libstdc++ and libjava Makefiles
make -C *-redhat-linux/libstdc++-v3
make -C *-redhat-linux/libjava

make prefix=$RPM_BUILD_ROOT%{_prefix} mandir=$RPM_BUILD_ROOT%{_mandir} \
  infodir=$RPM_BUILD_ROOT%{_infodir} install

FULLPATH=$(dirname $RPM_BUILD_ROOT%{_prefix}/lib/gcc-lib/%{_target_platform}/%{gcc_version}/cc1)

file $RPM_BUILD_ROOT/%{_prefix}/bin/* | grep ELF | cut -d':' -f1 | xargs strip || :
strip $FULLPATH/{cc1,cc1obj,cc1plus,cpp0,tradcpp0,f771,jc1,jvgenmain}

# fix some things
ln -sf gcc $RPM_BUILD_ROOT%{_prefix}/bin/cc
mkdir -p $RPM_BUILD_ROOT/lib
ln -sf ..%{_prefix}/bin/cpp $RPM_BUILD_ROOT/lib/cpp
ln -sf g77 $RPM_BUILD_ROOT%{_prefix}/bin/f77
rm -f $RPM_BUILD_ROOT%{_infodir}/dir
gzip -9 $RPM_BUILD_ROOT%{_infodir}/*.info*
# This clashes with jar from kaffe
# mv -f $RPM_BUILD_ROOT%{_prefix}/bin/jar $RPM_BUILD_ROOT%{_prefix}/bin/gcj-jar

mv $RPM_BUILD_ROOT%{_prefix}/bin/gcc $RPM_BUILD_ROOT%{_prefix}/bin/gcc3
mv $RPM_BUILD_ROOT%{_prefix}/bin/g++ $RPM_BUILD_ROOT%{_prefix}/bin/g++3
mv $RPM_BUILD_ROOT%{_prefix}/bin/g77 $RPM_BUILD_ROOT%{_prefix}/bin/g77-3
mv $RPM_BUILD_ROOT%{_prefix}/bin/c++filt $RPM_BUILD_ROOT%{_prefix}/bin/c++3filt
mv $RPM_BUILD_ROOT%{_prefix}/bin/gcj $RPM_BUILD_ROOT%{_prefix}/bin/gcj3
mv $RPM_BUILD_ROOT%{_prefix}/bin/gcjh $RPM_BUILD_ROOT%{_prefix}/bin/gcjh3
mv $RPM_BUILD_ROOT%{_prefix}/bin/jcf-dump $RPM_BUILD_ROOT%{_prefix}/bin/jcf3-dump
mv $RPM_BUILD_ROOT%{_prefix}/bin/jv-scan $RPM_BUILD_ROOT%{_prefix}/bin/jv3-scan
mv $RPM_BUILD_ROOT%{_prefix}/bin/jv-convert $RPM_BUILD_ROOT%{_prefix}/bin/jv3-convert
mv $RPM_BUILD_ROOT%{_prefix}/bin/gij $RPM_BUILD_ROOT%{_prefix}/bin/gij3
mv $RPM_BUILD_ROOT%{_mandir}/man1/gcc.1 $RPM_BUILD_ROOT%{_mandir}/man1/gcc3.1
mv $RPM_BUILD_ROOT%{_mandir}/man1/cpp.1 $RPM_BUILD_ROOT%{_mandir}/man1/cpp3.1
mv $RPM_BUILD_ROOT%{_mandir}/man1/g++.1 $RPM_BUILD_ROOT%{_mandir}/man1/g++3.1
pushd $RPM_BUILD_ROOT%{_infodir}
cat > changeinfo.sed <<"EOF"
s/Cpp: (cpp)/Cpp3: (cpp3)/g
s/Cpplib: (cppinternals)/Cpplib3: (cppinternals3)/g
s/g77: (g77)/g77-3: (g77-3)/g
s/gcc: (gcc)/gcc3: (gcc3)/g
s/gccint: (gccint)/gccint3: (gccint3)/g
s/cpp\.\(texi\|info\)/cpp3.\1/g
s/cppinternals\.\(texi\|info\)/cppinternals3.\1/g
s/g77\.\(texi\|info\)/g77-3.\1/g
s/gcc\.\(texi\|info\)/gcc3.\1/g
s/gccint\.\(texi\|info\)/gccint3.\1/g
EOF
for i in gcc.* cpp.* gccint.* cppint*; do
  j=`echo $i | sed 's~^\([^.]*\)\.\(.*\)$~\13.\2~'`
  zcat $i | sed -f changeinfo.sed | gzip -9 > $j; rm -f $i
done
for i in g77.*; do
  j=`echo $i | sed 's~^\([^.]*\)\.\(.*\)$~\1-3.\2~'`
  zcat $i | sed -f changeinfo.sed | gzip -9 > $j; rm -f $i
done
rm -f changeinfo.sed
popd
# mv $RPM_BUILD_ROOT%{_prefix}/bin/jar $RPM_BUILD_ROOT%{_prefix}/bin/jar3

mv $RPM_BUILD_ROOT%{_prefix}/lib/libgcj.*a $FULLPATH/
sed 's/-lgcjgc//g;s/-lzgcj//g;s/-lpthread//g' $RPM_BUILD_ROOT%{_prefix}/lib/libgcj.spec > $FULLPATH/libgcj.spec
mv $RPM_BUILD_ROOT%{_prefix}/include/gc*.h $FULLPATH/include/
mv $RPM_BUILD_ROOT%{_prefix}/include/j*.h $FULLPATH/include/
mv -f $RPM_BUILD_ROOT%{_prefix}/include/{java,javax,gnu} $FULLPATH/include/
mkdir -p $FULLPATH/include/gcj
mv -f $RPM_BUILD_ROOT%{_prefix}/include/gcj/* $FULLPATH/include/gcj/
rmdir $RPM_BUILD_ROOT%{_prefix}/include/gcj

mkdir -p $RPM_BUILD_ROOT/%{_lib}
mv -f $RPM_BUILD_ROOT%{_prefix}/lib/libgcc_s.so.1 $RPM_BUILD_ROOT/%{_lib}/libgcc_s-%{gcc_version}-%{DATE}.so.1
chmod 755 $RPM_BUILD_ROOT/%{_lib}/libgcc_s-%{gcc_version}-%{DATE}.so.1
ln -sf libgcc_s-%{gcc_version}-%{DATE}.so.1 $RPM_BUILD_ROOT/%{_lib}/libgcc_s.so.1
ln -sf ../../%{_lib}/libgcc_s.so.1 $RPM_BUILD_ROOT%{_prefix}/%{_lib}/libgcc_s.so
#ln -sf `echo "%{_prefix}" | sed 's~/[^/]*~\.\./~g'`../%{_lib}/libgcc_s.so.1 \
#  $RPM_BUILD_ROOT%{_prefix}/%{_lib}/libgcc_s.so
#mv -f $FULLPATH/libobjc.so.1* $RPM_BUILD_ROOT%{_prefix}/%{_lib}/
pushd $FULLPATH
if [ "%{_lib}" = "lib" ]; then
ln -sf ../../../libobjc.so.1 libobjc.so
ln -sf ../../../libstdc++.so.4.* libstdc++.so
ln -sf ../../../libgcj.so.3.* libgcj.so
ln -sf ../../../libg2c.so.0.* libg2c.so
else
ln -sf ../../../../%{_lib}/libobjc.so.1 libobjc.so
ln -sf ../../../../%{_lib}/libstdc++.so.4.* libstdc++.so
ln -sf ../../../../%{_lib}/libgcj.so.3.* libgcj.so
ln -sf ../../../../%{_lib}/libg2c.so.0.* libg2c.so
fi
mv -f $RPM_BUILD_ROOT%{_prefix}/lib/libstdc++.*a .
mv -f $RPM_BUILD_ROOT%{_prefix}/lib/libsupc++.*a .
mv -f $RPM_BUILD_ROOT%{_prefix}/lib/libg2c.*a .
mv -f $RPM_BUILD_ROOT%{_prefix}/lib/libfrtbegin.*a .
mv -f $RPM_BUILD_ROOT%{_prefix}/lib/libobjc.*a .
# Strip debug info from Fortran/ObjC/Java static libraries
strip -g libg2c.a libobjc.a libgcj.a
# Fix up .la files
for i in *.la; do
  sed -e '/^libdir/s_%{_prefix}/lib_%{_prefix}/lib/gcc-lib/%{_target_platform}/%{gcc_version}_' \
      -e '/^dependency_libs/s_%{_prefix}/lib_%{_prefix}/lib/gcc-lib/%{_target_platform}/%{gcc_version}_' \
      -e '/^dependency_libs/s~'\''$~ '\''~' \
      -e '/^dependency_libs/s~[ 	][ 	]*~ ~g' \
      -e '/^dependency_libs/s~-L[^ ]* ~~g' \
      -e '/^dependency_libs/s~-lgcc_s -lgcc -lc -lgcc_s -lgcc ~~g' \
      -e '/^dependency_libs/s~-lgcc -lc -lgcc ~~g' \
      -e '/^dependency_libs/s~-lc ~~g' \
      -e '/^dependency_libs/s~-lm \(-lm \)*~-lm ~g' \
      $i > $i.tmp
  mv -f $i.tmp $i
done
popd
chmod 755 $RPM_BUILD_ROOT%{_prefix}/lib/libg2c.so.0.*
chmod 755 $RPM_BUILD_ROOT%{_prefix}/lib/libobjc.so.1.*

%clean
rm -rf $RPM_BUILD_ROOT

%post
/sbin/install-info \
  --info-dir=%{_infodir} %{_infodir}/gcc3.info.gz
/sbin/install-info \
  --info-dir=%{_infodir} %{_infodir}/cpp3.info.gz

%preun
if [ $1 = 0 ]; then
  /sbin/install-info --delete \
    --info-dir=%{_infodir} %{_infodir}/gcc3.info.gz
  /sbin/install-info --delete \
    --info-dir=%{_infodir} %{_infodir}/cpp3.info.gz
fi

%post g77
/sbin/install-info \
  --info-dir=%{_infodir} %{_infodir}/g77-3.info.gz

%preun g77
if [ $1 = 0 ]; then
  /sbin/install-info --delete \
    --info-dir=%{_infodir} %{_infodir}/g77-3.info.gz
fi

%post -n libgcc -p /sbin/ldconfig

%postun -n libgcc -p /sbin/ldconfig

%post -n libstdc++3
if [ "%{_prefix}/%{_lib}" != /usr/lib ]; then
  if ! grep -q '^%{_prefix}/%{_lib}$' /etc/ld.so.conf; then
    echo %{_prefix}/%{_lib} >>/etc/ld.so.conf
  fi
fi
/sbin/ldconfig

%postun -n libstdc++3 -p /sbin/ldconfig

# %post -n libobjc -p /sbin/ldconfig

# %postun -n libobjc -p /sbin/ldconfig

%post -n libgcj3 -p /sbin/ldconfig

%postun -n libgcj3 -p /sbin/ldconfig

%post -n libf2c -p /sbin/ldconfig

%postun -n libf2c -p /sbin/ldconfig

%files
%defattr(-,root,root)
%{_prefix}/bin/gcc3
%{_mandir}/man1/gcc3.1*
%{_mandir}/man1/cpp3.1*
%{_infodir}/gcc*
%{_infodir}/cpp*
%dir %{_prefix}/lib/gcc-lib
%dir %{_prefix}/lib/gcc-lib/%{_target_platform}
%dir %{_prefix}/lib/gcc-lib/%{_target_platform}/%{gcc_version}
%dir %{_prefix}/lib/gcc-lib/%{_target_platform}/%{gcc_version}/include
%{_prefix}/lib/gcc-lib/%{_target_platform}/%{gcc_version}/include/stddef.h
%{_prefix}/lib/gcc-lib/%{_target_platform}/%{gcc_version}/include/stdarg.h
%{_prefix}/lib/gcc-lib/%{_target_platform}/%{gcc_version}/include/varargs.h
%{_prefix}/lib/gcc-lib/%{_target_platform}/%{gcc_version}/include/float.h
%{_prefix}/lib/gcc-lib/%{_target_platform}/%{gcc_version}/include/limits.h
%{_prefix}/lib/gcc-lib/%{_target_platform}/%{gcc_version}/include/stdbool.h
%{_prefix}/lib/gcc-lib/%{_target_platform}/%{gcc_version}/include/iso646.h
%{_prefix}/lib/gcc-lib/%{_target_platform}/%{gcc_version}/include/syslimits.h
%ifarch ia64
%{_prefix}/lib/gcc-lib/%{_target_platform}/%{gcc_version}/include/ia64intrin.h
%endif
%{_prefix}/lib/gcc-lib/%{_target_platform}/%{gcc_version}/include/README
%{_prefix}/lib/gcc-lib/%{_target_platform}/%{gcc_version}/cc1
%{_prefix}/lib/gcc-lib/%{_target_platform}/%{gcc_version}/collect2
%{_prefix}/lib/gcc-lib/%{_target_platform}/%{gcc_version}/crt*.o
%{_prefix}/lib/gcc-lib/%{_target_platform}/%{gcc_version}/libgcc.a
%{_prefix}/lib/gcc-lib/%{_target_platform}/%{gcc_version}/libgcc_eh.a
%{_prefix}/lib/gcc-lib/%{_target_platform}/%{gcc_version}/specs
%{_prefix}/lib/gcc-lib/%{_target_platform}/%{gcc_version}/cpp0
%{_prefix}/lib/gcc-lib/%{_target_platform}/%{gcc_version}/tradcpp0
%{_prefix}/%{_lib}/libgcc_s.so
%doc gcc/README* gcc/*ChangeLog*

%files -n libgcc
%defattr(-,root,root)
/%{_lib}/libgcc_s-%{gcc_version}-%{DATE}.so.1
/%{_lib}/libgcc_s.so.1

%files c++
%defattr(-,root,root)
%{_prefix}/bin/g++3
%{_prefix}/bin/c++3filt
%{_mandir}/man1/g++3.1*
%dir %{_prefix}/lib/gcc-lib
%dir %{_prefix}/lib/gcc-lib/%{_target_platform}
%dir %{_prefix}/lib/gcc-lib/%{_target_platform}/%{gcc_version}
%{_prefix}/lib/gcc-lib/%{_target_platform}/%{gcc_version}/cc1plus
%doc gcc/cp/ChangeLog*

%files -n libstdc++3
%defattr(-,root,root)
%{_prefix}/%{_lib}/libstdc++.so.4*

%files -n libstdc++3-devel
%defattr(-,root,root)
%{_prefix}/include/g++-v3
%{_prefix}/lib/gcc-lib/%{_target_platform}/%{gcc_version}/libstdc++.so
%{_prefix}/lib/gcc-lib/%{_target_platform}/%{gcc_version}/libstdc++.*a
%{_prefix}/lib/gcc-lib/%{_target_platform}/%{gcc_version}/libsupc++.*a
%doc libstdc++-v3/ChangeLog* libstdc++-v3/README* libstdc++-v3/docs/html/

%files objc
%defattr(-,root,root)
%dir %{_prefix}/lib/gcc-lib
%dir %{_prefix}/lib/gcc-lib/%{_target_platform}
%dir %{_prefix}/lib/gcc-lib/%{_target_platform}/%{gcc_version}
%dir %{_prefix}/lib/gcc-lib/%{_target_platform}/%{gcc_version}/include
%{_prefix}/lib/gcc-lib/%{_target_platform}/%{gcc_version}/include/objc
%{_prefix}/lib/gcc-lib/%{_target_platform}/%{gcc_version}/cc1obj
%{_prefix}/lib/gcc-lib/%{_target_platform}/%{gcc_version}/libobjc.*a
%{_prefix}/lib/gcc-lib/%{_target_platform}/%{gcc_version}/libobjc.so
%doc rpm.doc/objc/*
%doc libobjc/THREADS* libobjc/ChangeLog

#%files -n libobjc
#%defattr(-,root,root)
#%{_prefix}/%{_lib}/libobjc.so.1*

%files g77
%defattr(-,root,root)
%{_prefix}/bin/g77-3
%{_infodir}/g77*
%dir %{_prefix}/lib/gcc-lib
%dir %{_prefix}/lib/gcc-lib/%{_target_platform}
%dir %{_prefix}/lib/gcc-lib/%{_target_platform}/%{gcc_version}
%dir %{_prefix}/lib/gcc-lib/%{_target_platform}/%{gcc_version}/include
%{_prefix}/lib/gcc-lib/%{_target_platform}/%{gcc_version}/f771
%{_prefix}/lib/gcc-lib/%{_target_platform}/%{gcc_version}/libfrtbegin.a
%{_prefix}/lib/gcc-lib/%{_target_platform}/%{gcc_version}/libg2c.*a
%{_prefix}/lib/gcc-lib/%{_target_platform}/%{gcc_version}/libg2c.so
%{_prefix}/lib/gcc-lib/%{_target_platform}/%{gcc_version}/include/g2c.h
%doc gcc/f/README rpm.doc/g77/*

%files -n libf2c
%defattr(-,root,root)
%{_prefix}/%{_lib}/libg2c.so.0*

%files java
%defattr(-,root,root)
%{_prefix}/bin/gcj3
%{_prefix}/bin/gcjh3
%{_prefix}/bin/jcf3-dump
%{_prefix}/bin/jv3-scan
%dir %{_prefix}/lib/gcc-lib
%dir %{_prefix}/lib/gcc-lib/%{_target_platform}
%dir %{_prefix}/lib/gcc-lib/%{_target_platform}/%{gcc_version}
%{_prefix}/lib/gcc-lib/%{_target_platform}/%{gcc_version}/jc1
%{_prefix}/lib/gcc-lib/%{_target_platform}/%{gcc_version}/jvgenmain
%doc gcc/java/ChangeLog*

%files -n libgcj3
%defattr(-,root,root)
%{_prefix}/bin/jv3-convert
%{_prefix}/bin/gij3
%{_prefix}/bin/jar
%{_prefix}/%{_lib}/libgcj.so.*
%{_prefix}/share/java

%files -n libgcj3-devel
%defattr(-,root,root)
%{_prefix}/bin/addr2name.awk
%{_prefix}/lib/gcc-lib/%{_target_platform}/%{gcc_version}/libgcj.*a
%{_prefix}/lib/gcc-lib/%{_target_platform}/%{gcc_version}/libgcj.so
%{_prefix}/lib/gcc-lib/%{_target_platform}/%{gcc_version}/libgcj.spec
%{_prefix}/lib/gcc-lib/%{_target_platform}/%{gcc_version}/include/gc*.h
%{_prefix}/lib/gcc-lib/%{_target_platform}/%{gcc_version}/include/j*.h
%{_prefix}/lib/gcc-lib/%{_target_platform}/%{gcc_version}/include/java
%{_prefix}/lib/gcc-lib/%{_target_platform}/%{gcc_version}/include/javax
%{_prefix}/lib/gcc-lib/%{_target_platform}/%{gcc_version}/include/gnu
%{_prefix}/lib/gcc-lib/%{_target_platform}/%{gcc_version}/include/gcj
%doc rpm.doc/boehm-gc/* rpm.doc/fastjar/* rpm.doc/libffi/*
%doc rpm.doc/libjava/*

%changelog
* Wed May 15 2002 Jakub Jelinek <jakub@redhat.com> 3.1-1
- update to 3.1 final
- 15 new patches
  - fix PR c/6643
  - fix fold-const.c typo
  - fix unitialized pointer-to-member values (Alexandre Oliva)
  - fix templates with asm inputs (Jason Merrill)
  - fix -fdata-section (Andreas Schwab)
  - readd warning about i386 -malign-double into documentation (Jan Hubicka)
  - fix PR libstdc++/6594 (Ben Kosnik)
  - fix PR PR libstdc++/6648 (Paolo Carlini)
  - fix libstdc++ testsuite rlimits (Rainer Orth)
  - s390 java support (Gerhard Tonn)
  - rotate testcases (Tom Rix)
  - build libiberty with -fpic on x86_64 (Andreas Schwab)
  - fix x86_64 multilib build (Bo Thorsen)
  - fix x86_64 ASM_OUTPUT_MI_THUNK (Jan Hubicka)
  - fix loop-2[cd].c tests on i386 (Eric Botcazou)
- fix typo in g77 info files tweaking
- fix libgcj.so symlink

* Thu May  9 2002 Jakub Jelinek <jakub@redhat.com> 3.1-0.28
- update to CVS 3.1 branch
  - PR c++/6212, target/6429, opt/6534, c/6543, target/6561, c/6569
- fix x86_64 q_regs_operand (Jan Hubicka)
- better PR c++/6381 fix (Jason Merrill)

* Fri May  3 2002 Jakub Jelinek <jakub@redhat.com> 3.1-0.27
- update to CVS 3.1 branch
  - PR target/5628, libstdc++/5820, c++/6396, preprocessor/6489,
    libstdc++/6501, libstdc++/6511, target/6512, libstdc++/6513,
    bootstrap/6514, opt/6516, bootstrap/6525, c++/6527, libstdc++/6533,
    target/6540
- fix PR target/6542, target/6522, libstdc++/6549

* Mon Apr 29 2002 Jakub Jelinek <jakub@redhat.com> 3.1-0.26
- update to CVS 3.1 branch
  - PR c/3581, libstdc++/4150, libstdc++/4164, c/5154, c/5430, c++/5504,
    c++/5658, c++/5719, f/6138, libgcj/6158, middle-end/6205, c++/6256,
    c/6300, c++/6331, c/6343, c/6344, c++/6352, c/6358, libstdc++/6360,
    c++/6395, target/6413, libstdc++/6414, target/6422, bootstrap/6445,
    optimization/6475, target/6476, c++/6477, c++/6479, c++/6486, c++/6492,
    target/6494, target/6496, c/6497, target/6500
- fix PR c++/6396
- run make check as part of build process

* Wed Apr 17 2002 Jakub Jelinek <jakub@redhat.com> 3.1-0.25
- update to CVS 3.1 branch
  - PR opt/420, c++/525, target/817, target/1538, opt/3967, target/3997,
    opt/4120, bootstrap/4191, opt/4311, optimization/4328, c++/4884, c++/4934,
    c/5078, c++/5104, opt/5120, c++/5189, c++/5373, target/5446, c/5484,
    c++/5507, c++/5571, c++/5636, target/5672, target/5715, target/5886,
    c++/5933, c++/5964, c++/5998, opt/6007, target/6032, target/6041,
    target/6054, c++/6073, target/6082, optimization/6086, target/6087,
    middle-end/6096, middle-end/6098, middle-end/6099, middle-end/6100,
    middle-end/6102, fortran/6106, c++/6119, opt/6165, optimization/6177,
    c++/6179, optimization/6189, c/6202, c/6223, optimization/6233,
    middle-end/6279, c/6290, optimization/6305, target/6305, bootstrap/6315,
    c++/6320...
- fix PR c++/6316

* Wed Mar 27 2002 Jakub Jelinek <jakub@redhat.com> 3.1-0.24
- update to CVS 3.1 branch
  - PRs c/5656, c/5972, bootstrap/4192, target/4792, bootstrap/4195,
    optimization/5854, target/6043, c++/6037, bootstrap/4128, target/5740,
    c/5597, optimization/5863, optimization/5742, target/3177, c/5354,
    optimization/5999, target/5977, middle-end/5731, target/5312...

* Fri Mar 15 2002 Jakub Jelinek <jakub@redhat.com> 3.1-0.23.1
- fix info and man page generation

* Thu Mar 14 2002 Jakub Jelinek <jakub@redhat.com> 3.1-0.23
- update to CVS 3.1 branch
  - fix IA-64 packet selection (PR optimization/5892)
  - make highest_pow2_factor work for all constants (PR middle-end/5877)
  - fix -Wunused (#61047)
  - fix loop on mixed mode class assignments (#60923)
  - fix wide character literals
  - support SPARC v9 long distance branches (PR target/5626)
  - fix SPARC leaf functions
  - fix a rtl sharing problem (Richard Henderson, #60760,
    PR optimization/5844)
  - fix va_arg with variable size types (PR c/3711)
  - PRs optimization/5901, optimization/5878, 5693, preprocessor/5899
- fix C++ ?: at the end of stmt expr (PR c++/5373)
- fix loop unrolling with sibcalls (PR optimization/5891)

* Fri Mar  8 2002 Jakub Jelinek <jakub@redhat.com> 3.1-0.22
- rework spec file to build as secondary compiler

* Thu Mar  7 2002 Jakub Jelinek <jakub@redhat.com> 3.1-0.22
- update to CVS 3.1 branch
  - fix ICE with volatile long long (#60650)
  - fix tempbuf.h (Philipp Thomas, #60212)
  - fix -fssa-ccp (Jeff Law, #60651)
  - versioned libstdc++
  - backport __attribute__((visibility("..."))) patches from trunk
- include libstdc++ html documentation

* Tue Feb  5 2002 Jakub Jelinek <jakub@redhat.com> 3.1-0.21
- update to CVS HEAD
  - fix demangler (H.J. Lu, #59300, #59310)
  - fix typo in IA-32 specs file (#59081)
  - support moving SFmode values in MMX regs if -mmmx (#59083)
  - fix recog_for_combine (#59084)
  - don't ICE when inserting insns on edge from bb0 to bb0 (Bernd Schmidt,
    #59087)
  - make sure configure has not time in the future (#59203)
  - fix division/modulo by certain constants (#58065, PR c/5304)
  - fix -Wswitch (PR c/4475)

* Thu Jan 31 2002 Jakub Jelinek <jakub@redhat.com> 3.1-0.20
- update to CVS HEAD
  - fix jar (Tom Tromey)
  - fix loop unrolling (Richard Henderson)

* Wed Jan 30 2002 Jakub Jelinek <jakub@redhat.com> 3.1-0.19
- update to CVS HEAD
  - fix a reload bug on ia32 (#58579, #58648)
  - issue error about unknown -W* options (#58909)
  - fix ia64 libbfd miscompilation (#58694)
  - register all pending unparsed_text structures with GC (#58647)
  - fix __builtin_apply with ia32 -msse (#58447)
  - prevent ia64 prologue insns saving regs required for eh from being
    deleted (#58387)

* Tue Jan 15 2002 Jakub Jelinek <jakub@redhat.com> 3.1-0.18
- update to CVS HEAD
  - handle static x[] = { [X...Y] = (foo) { Z } } (#58338)
  - fix getdents.os miscompilation (Richard Henderson, #58308)
  - fix ICE in try_forward_edges (#58125)
  - fix ICE with -fexceptions -foptimize-sibling-calls

* Tue Jan  8 2002 Jakub Jelinek <jakub@redhat.com> 3.1-0.17
- avoid division by 0 when computing prediction probabilities (#57992)
- fix ICE due to store_expr not adjusting value back for mode
- increase -ftemplate-depth default value to 500

* Mon Jan  7 2002 Jakub Jelinek <jakub@redhat.com> 3.1-0.16
- if using PT_GNU_EH_FRAME registry, work around assembler bug resp. feature
  and don't provide weak prototypes of functions which won't be used
- on Alpha, fix a typo so that crtbeginT.o is built and installed
- fix glibc inl-tester miscompilation on ia32

* Sun Jan  6 2002 Jakub Jelinek <jakub@redhat.com> 3.1-0.15
- update to CVS HEAD (fix glibc bootstrap failure)

* Thu Jan  3 2002 Jakub Jelinek <jakub@redhat.com> 3.1-0.14
- update to CVS HEAD (#57907)
  - fix alpha bootstrap (Richard Henderson)
- fix simplification of (div:SI (???:DI ???) (const_int 1))
  (#57916)
- add contrib/gcc_update --touch

* Tue Jan  1 2002 Jakub Jelinek <jakub@redhat.com> 3.1-0.13
- update to CVS HEAD (fix glibc miscompilation on alpha)
- fix objc to not emit __objc_class_name_* without type and size

* Mon Dec 31 2001 Jakub Jelinek <jakub@redhat.com> 3.1-0.12
- update to CVS HEAD
- fix sed commands for .la files
- make Alpha use PT_GNU_EH_FRAME

* Thu Dec 27 2001 Jakub Jelinek <jakub@redhat.com> 3.1-0.11
- update to CVS HEAD (#57165, #57212, #57467, #57488, #57502,
  #57505, #57574)
- readd .la files after fixing them up by sed
- add %%defattr(-,root,root) to libobjc subpackage

* Mon Dec  3 2001 Jakub Jelinek <jakub@redhat.com> 3.1-0.10
- one more gcc.spec fix for passing --gdwarf-2 resp. --gstabs to as
- fix conditional register dead computation on IA-64
- fix extern array of incomplete structures handling
- fix gcc -xc -
- fix Fortran ICEs with SAVE_EXPRs (Richard Kenner)

* Tue Nov 27 2001 Jakub Jelinek <jakub@redhat.com> 3.1-0.9
- update to CVS HEAD
- make DWARF 2 preferred debugging format on Linux

* Mon Nov 12 2001 Jakub Jelinek <jakub@redhat.com> 3.1-0.8
- don't ship .la files (#56072)
- include libfrtbegin.a (#56098)

* Mon Nov 12 2001 Jakub Jelinek <jakub@redhat.com> 3.1-0.7
- update to CVS HEAD
- back out Nov 7th loop.c change for now

* Fri Nov  9 2001 Jakub Jelinek <jakub@redhat.com> 3.1-0.6
- update to CVS HEAD
- frame unwind compatibility with 7.[12] binutils

* Tue Nov  6 2001 Jakub Jelinek <jakub@redhat.com> 3.1-0.5
- update to CVS HEAD
- merge DW_EH_PE_indirect constants and their relocs

* Thu Oct 25 2001 Jakub Jelinek <jakub@redhat.com> 3.1-0.4
- don't loop forever or ICE on bogus array initializers (#53704)
- fix store motion with pure calls
- disable store motion for now

* Tue Oct 23 2001 Jakub Jelinek <jakub@redhat.com> 3.1-0.3
- fix inlining of C nested functions with auto prototypes

* Mon Oct 22 2001 Jakub Jelinek <jakub@redhat.com> 3.1-0.2
- update to CVS HEAD
- tree inlining fix from Alexandre Oliva
- fix anonymous union ICE on alpha

* Mon Oct 15 2001 Jakub Jelinek <jakub@redhat.com> 3.1-0.1
- switch package to main compiler from alternate compiler
- update to CVS HEAD
- early gcc-2.96-RH compatibility in __frame_state_for
- change weak function tests for functions always present in GLIBC 2.2
  into simple non-weak calls in crt*.o to avoid unnecessary symbol
  lookups and prelink conflicts
- don't link against libgcc_s C shared libraries

* Tue Oct  2 2001 Jakub Jelinek <jakub@redhat.com> 3.0.1-4
- update from CVS 3.0 branch
  - ia64 function descriptors in vtables
- handle large files in Fortran (#53328)
- allow Java programs to be statically linked (#53605)
- remove #include_next patch, Benjamin commited it

* Thu Sep  6 2001 Jakub Jelinek <jakub@redhat.com> 3.0.1-3
- don't use #include_next in <bits/std_c*> headers (Benjamin Kosnik, #53262)

* Wed Sep  5 2001 Jakub Jelinek <jakub@redhat.com> 3.0.1-2
- update from CVS 3.0 branch
- check all gcc-2.96-RH patches whether they have made it into 3.0.1,
  and if not, whether they are appropriate for 3.0.1
- 8 new patches
  - add 36 testcases from gcc-2.96-RH
  - fix ICE on very questionable C++ code from JDK (#39858, #52960)
  - fix -frepo (Nathan Sidwell, #52877)
  - avoid generating bogus .stabs (#49214)
  - issue a clear error message about invalid ia32 floating point
    asm constraints (#27137)
  - fix some comment typos
  - fix ADDRESSOF recognition (#29686)

* Mon Aug 27 2001 Jakub Jelinek <jakub@redhat.com> 3.0.1-1
- update from CVS (3.0.1 final)
- properly handle throw() exception specifiers in template decls (#51824)
- fix IA-64 varargs handling in presence of additional anonymous arguments
  (#50757)
- fix boehm-gc for prelink
- fix a typo in gcc3-c++ description (#52323)
- remove Chill from package summary (#51764)

* Tue Aug  7 2001 Jakub Jelinek <jakub@redhat.com> 3.0-6
- update from CVS
  - fix glibc vfprintf miscompilation
- don't warn about if (&foo) if foo is weak (H.J.Lu, #50855)

* Wed Jul 25 2001 Jakub Jelinek <jakub@redhat.com> 3.0-5
- include libgcjgc.a in libgcj3-devel
- include libgcjgc.so.* in libgcj3 on ia64
- remove dependency on libgcj on ia64
- add ldconfig to libgcj3 post/postun

* Tue Jul 24 2001 Jakub Jelinek <jakub@redhat.com> 3.0-4
- update from CVS
- make gcc3-java/libgcj3* packages, so that they can coexist
  with 2.96-RH Java
- make sure shared Java libraries are built with proper dependencies

* Wed Jul 11 2001 Jakub Jelinek <jakub@redhat.com> 3.0-3
- fix libgcc_s.so and libstdc++.so symlinks
- don't ship jar

* Tue Jul 10 2001 Jakub Jelinek <jakub@redhat.com> 3.0-2
- move libstdc++.so into gcc-lib
- add libobjc.so symlink

* Tue Jul 10 2001 Jakub Jelinek <jakub@redhat.com> 3.0-1
- new rpm
